routes/web.php
<?php

use App\Http\Controllers\NewsController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [App\Http\Controllers\NewsController::class, 'index']);

Route::resource('news', NewsController::class);
Route::resource('news.comments', \App\Http\Controllers\CommentsController::class)
    ->only(['store', 'update', 'destroy']);

Auth::routes();


Route::get('admin', [\App\Http\Controllers\HomeController::class, 'index'])
        ->name('home');

app/Models/News.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;
use Illuminate\Database\Eloquent\Relations\HasMany;

class News extends Model
{
    use HasFactory;

    /**
     * @var string[]
     */
    protected $fillable = [
        'body',
        'user_id',
        'category_id',
        'publication_date',
        'quality',
        'relevance',
        'satisfied'
    ];


    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    /**
     * @return BelongsTo
     */
    public function category(): BelongsTo
    {
        return $this->belongsTo(Category::class);
    }


    /**
     * @return BelongsToMany
     */
    public function tags(): BelongsToMany
    {
        return $this->belongsToMany(Tag::class);
    }

    /**
     * @return HasMany
     */
    public function comments(): HasMany
    {
        return $this->hasMany(Comment::class);
    }
}

app/Http/Controllers/NewsController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\NewsRequest;
use App\Models\Category;
use App\Models\News;
use App\Models\Tag;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

class NewsController extends Controller
{
    /**
     * @return Application|Factory|View
     */
    public function index()
    {
        $news = News::orderBy('id', 'desc')->paginate(3);
        return view('news.index', compact('news'));
    }


    /**
     * @return Application|Factory|View
     */
    public function create()
    {
        $categories = Category::all();
        $tags = Tag::all();
        return view('news.create', compact('categories', 'tags'));
    }


    /**
     * @param NewsRequest $request
     * @return RedirectResponse
     */
    public function store(NewsRequest $request): RedirectResponse
    {
        $news = new News();
        $news->body = $request->input('body');
        $news->user()->associate($request->user());
        $news->category_id = $request->input('category_id');
        $news->publication_date = $request->input('publication_date');
        $news->quality = $request->input('quality');
        $news->relevance = $request->input('relevance');
        $news->satisfied = $request->input('satisfied');

        $news->save();
        return redirect()->route('news.index')->with('status', "Новость успешно создана!");
    }


    /**
     * @param News $news
     * @return Application|Factory|View
     */
    public function show(News $news)
    {
        $comments = $news->comments()->orderByDesc('updated_at')->paginate(5);
        return view('news.show', compact('news', 'comments'));
    }


    /**
     * @param News $news
     * @return Application|Factory|View
     */
    public function edit(News $news)
    {
        $categories = Category::all();
        $tags = Tag::all();
        return view('news.edit', compact('news', 'categories', 'tags'));
    }


    /**
     * @param NewsRequest $request
     * @param News $news
     * @return RedirectResponse
     */
    public function update(NewsRequest $request, News $news): RedirectResponse
    {
        $data = $request->all();
        $news->update($data);

        return redirect()->route('news.index')->with('status', 'Новость успешно обновлена!');
    }


    /**
     * @param News $news
     * @return RedirectResponse
     */
    public function destroy(News $news)
    {
        $news->delete();
        return redirect()->route('news.index')->with('status', 'Новость успешно удалена!');
    }
}

resources/views/news/create.blade.php
@extends('layouts.app')
@section('content')
    <div>
        <h1>Create news</h1>
        <form enctype="multipart/form-data" method="post" action="{{ route('news.store') }}">
            @csrf
            <div class="form-group">
                <label for="bodyNews"><b>Текст новости</b></label>
                <textarea class="form-control" name="body" id="bodyNews" cols="30" rows="10" placeholder="Введите новость..."></textarea>
                @error('body')
                <div class="alert alert-danger">{{$message}}</div>
                @enderror
            </div>
            <div class="form-group">
                <label for="category"><b>Select a category:</b></label>
                <select class="form-control border-success  @error('category_id') is-invalid border-danger @enderror"
                        id="category"  name="category_id">
                    <option value="" selected >'Choose'</option>
                    @foreach($categories as $category)
                        <option value="{{$category->id}}">{{$category->name}}</option>
                    @endforeach
                </select>
            </div>
            @error('category_id')
            <p class="text-danger">{{ $message }}</p>
            @enderror
            <label for="tags_id"><b>Add tags</b></label>
            <div  id="tags">
                <div class="card card-body" style="margin: 5px">
                    @foreach($tags as $tag)
                        <div class="form-check">
                            <input class="form-check-input" name="tags[]" type="checkbox"
                                   value=" {{ $tag->id }} " id="tags{{$tag->id}}">
                            <label class="form-check-label" for="tags{{$tag->id}}">
                                {{$tag->tag}}
                            </label>
                        </div>
                    @endforeach
                </div>
            </div>
            <button type="submit" class="btn btn-primary">Сохранить</button>
        </form>
    </div>
@endsection

resources/views/news/edit.blade.php
@extends('layouts.app')
@section('content')
    <div>
        <h1>Edit news</h1>
        <form enctype="multipart/form-data" method="post" action="{{ route('news.update', ['news' => $news]) }}">
            @csrf
            @method('PUT')
            <div class="form-group">
                <label for="bodyNews"><b>Текст новости</b></label>
                <textarea class="form-control" name="body" id="bodyNews" cols="30" rows="10" >{{$news->body}}</textarea>
                @error('body')
                <div class="alert alert-danger">{{$message}}</div>
                @enderror
            </div>
            <div class="form-group">
                <label for="category"><b>Select a category:</b></label>
                <select class="form-control border-success  @error('category_id') is-invalid border-danger @enderror"
                        id="category"  name="category_id">
                    <option value="" selected >'Choose'</option>
                    @foreach($categories as $category)
                        <option value="{{$category->id}}" @if($category == $news->category) selected @endif>{{$category->name}}</option>
                    @endforeach
                </select>
            </div>
            @error('category_id')
            <p class="text-danger">{{ $message }}</p>
            @enderror
            <label for="tags_id"><b>Add tags</b></label>
            <div id="tags">
                <div class="card card-body" style="margin: 5px">
                    @foreach($tags as $tag)
                        <div class="form-check">
                            <input class="form-check-input" name="tags[]" type="checkbox"
                                   value=" {{ $tag->id }} " id="tags{{$tag->id}}"
                                   @if (count($news->tags->where('id', $tag->id)))
                                   checked
                                @endif>
                            <label class="form-check-label" for="tags{{$tag->id}}">
                                {{$tag->tag}}
                            </label>
                        </div>
                    @endforeach
                </div>
            </div>
            <button type="submit" class="btn btn-primary">Сохранить</button>
        </form>
    </div>
@endsection

resources/views/news/index.blade.php
@extends('layouts.app')
@section('content')

        <h1>All news</h1>
        @if(\Illuminate\Support\Facades\Auth::check())
        <div>
            <a href="{{route('news.create')}}" type="button" class="btn btn-sm btn-secondary" >Add news</a>
        </div>
        @endif
        <div class="row">
        @if($news->count() > 0)
        @foreach($news as $one_news)
            @if(!is_null($one_news->publication_date) && strtotime(NOW()) >= strtotime(date($one_news->publication_date)))
                    <div class="col-12">
            <div class="card" style="margin: 10px">
                <div class="card-body">
                    <p class="card-text">{{$one_news->body}}</p>
                    <h5 class="card-title">Author: {{$one_news->user->name}}</h5>
                    <p class="card-text"><small class="text-muted">Date of creation {{ $one_news->created_at->format('d M Y - H:i') }}</small></p>
                    <p class="card-text"><small class="text-muted">Date of publication {{ date($one_news->publication_date) }}</small></p>
                    <a href="{{route('news.show', ['news' => $one_news])}}" class="card-link">Show more...</a>
                </div>
            </div>
                    </div>
                    @endif
        @endforeach
            <div class="row justify-content-md-center p-5">
                <div class="col-md-auto">
                    {{$news->links('pagination::bootstrap-4') }}
                </div>
            </div>
        @else
            <p>No published news</p>
        @endif
    </div>

@endsection

resources/views/news/show.blade.php
@extends('layouts.app')
@section('content')
    <div class="card mb-3">
        <div class="row g-0">
            <div class="col-md-8">
                <div class="card-body">
                    <p class="card-text">{{$news->body}}</p>
                    @foreach($news->tags as $tag)
                        <span><b>#{{$tag->tag}}</b></span>
                    @endforeach
                    <h5 class="card-title" style="margin: 5px">Author: {{$news->user->name}}</h5>
                    <p class="card-text"><small class="text-muted">Date of creation {{ $news->created_at->format('d M Y - H:i') }}</small></p>
                    <p class="card-text"><small class="text-muted">Date of publication {{ date($news->publication_date) }}</small></p>
                    <div class="btn-group">
                   <a href="{{route('news.edit', ['news' => $news])}}" class="card-link">Edit</a>
                   <form action="{{route('news.destroy',['news' => $news])}}" method="post">
                        @method('DELETE')
                        @csrf
                        <button class="btn btn-link" type="submit">Remove</button>
                    </form>
                    </div>
                </div>
            </div>
        </div>
    </div>

    @if($comments->count() > 0)
        <div class="list-group">
            @foreach($comments as $comment)
                <div class="list-group-item list-group-item-action shadow-lg">
                    <div class="d-flex justify-content-between align-items-center">
                        <div class="w-75">
                            <h5 class="mb-1">
                                <a href="" class="text-decoration-none">{{ $comment->user->name }}</a>
                            </h5>
                            <p class="mb-1"><em>{{ $comment->body }}</em></p>
                            <div class="accordion accordion-flush" id="accordionFlushExample">
                                <div class="accordion-item">
                                    <div id="flush-collapse{{ $comment->id }}" class="accordion-collapse collapse"
                                         aria-labelledby="flush-heading"
                                         data-bs-parent="#accordionFlushExample">
                                        <div class="accordion-body">
                                            <form
                                                action="{{ route('news.comments.update', ['news' => $news, 'comment' => $comment]) }}"
                                                method="POST">
                                                @csrf
                                                @method('PUT')
                                                <div class="row">
                                                    <div class="input-group">
                                                    <textarea class="form-control border-info"
                                                              name="body"
                                                              aria-label="With textarea"
                                                              cols="30" rows="5">{{ $comment->body }}</textarea>
                                                    </div>
                                                </div>
                                                <div class="row mt-2 mb-5">
                                                    <div class="col-12">
                                                        <button type="submit" class="btn btn-outline-info">Edit</button>
                                                    </div>
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div>
                            <small class="text-muted">{{ $comment->updated_at->diffForHumans() }}</small>
                            @can('delete', $comment)
                                <form
                                    action="{{ route('news.comments.destroy', ['news' => $news, 'comment' => $comment]) }}"
                                    method="POST" class="text-end">
                                    @method('DELETE')
                                    @csrf
                                    <button class="btn btn-outline-info btn-sm" type="button" data-bs-toggle="collapse"
                                            data-bs-target="#flush-collapse{{ $comment->id }}" aria-expanded="false"
                                            aria-controls="flush-collapse{{ $comment->id }}">
                                        <i class="fa fa-pencil"></i>
                                    </button>
                                    <button type="submit" class="btn btn-outline-danger btn-sm">
                                        Remove
                                    </button>
                                </form>
                            @endcan
                        </div>
                    </div>
                </div>
            @endforeach
        </div>
        <div class="row justify-content-md-center mt-5">
            <div class="col-md-auto">
                {{ $comments->withQueryString()->links('pagination::bootstrap-4') }}
            </div>
        </div>
    @endif

        <div>
            <h3 class="mt-5 mb-3">Add comment</h3>
            <form action="{{ route('news.comments.store', $news) }}" method="POST">
                @csrf
                <div class="row">
                    <div class="input-group">
                        <textarea class="form-control border-info @error('body') is-invalid border-danger @enderror"
                                  name="body" aria-label="With textarea"
                                  cols="30" rows="5" ></textarea>
                    </div>
                    @error('body')
                    <div class="alert alert-danger">{{$message}}</div>
                    @enderror
                </div>
                <div class="row mt-2 mb-5">
                    <div class="col-12">
                        <button type="submit" class="btn btn-outline-info">Add</button>
                    </div>
                </div>
            </form>
        </div>


    <a href="{{route('news.index')}}">Back to all news</a>

@endsection